## Meta Sepia
#
# sepia.rb
#
# author::    Peter Rullmann (mailto:peter@p4n.net)
# copyright:: Copyright (c) 2006-2008 Peter Rullmann
#
# You can Freely distribute this program under the GNU General Public
# License. See the file "COPYING" for the exact licensing terms.

require 'gtk2'
require 'libglade2'
require 'digest/md5'

# this has to be put in gui.rb
GetText.bindtextdomain("SEPIA", nil, nil, "UTF-8")
$glade = GladeXML.new("sepia.glade", nil, "SEPIA", nil,
                      GladeXML::FILE) { |handler| method(handler) }

require 'metadatatypes.rb'
require 'location.rb'
require 'sidebar.rb'
require 'views.rb'


# debug helper function shows name and value of local and instance variables.
# usage: env binding
#     or env binding, :some_var, "@another_var", "var.method", "expression"
# if vars are given, shows only these variables, else all.
# vars can be arbitrary expressions or symbols.
def env(context, *vars)
  vars = eval("local_variables | instance_variables", context) if vars.empty?
  fr = (caller[0][/.*?:/] == caller[1][/.*?:/] ? caller[1][/\d+(:|$)/] :
        caller[1][/[^\/]+:\d+:?/]) + caller[1][/in .*/].to_s if !caller[1].nil?
  puts "\nENV at " + caller[0] + (fr.to_s == "" ? "" : " (from " + fr + ")")
  vars.each { |v| puts "   " + v.to_s + " = " + eval(v.to_s, context).inspect }
end




class TestGlade

  attr :glade
  
  def initialize
    init_content
    $glade["window1"].show_all
    init_view_icon
    $glade["window1"].show_all
    $glade["window1"].signal_connect("delete_event") { Gtk.main_quit }
    $location.signal_emit("changed")
  end

  def init_content()

    #treestore = Gtk::TreeStore.new(String, Integer)
    #$glade["savedviews"].model= treestore
    #elems = []
    #[["no view for this directory", 0],
    #         ["this type view", 1], ["system default view", 1]]
    #elems.each() do |elem|
    #  node = treestore.append nil
    #  node[0] = (elem[1] == 1 ? elem[0] :
    #  	         "<span foreground=\"grey\">#{elem[0]}</span>")
    #  node[1] = elem[1]
    #end
    #col = Gtk::TreeViewColumn.new("", Gtk::CellRendererText.new, :markup => 0)
    #$glade["savedviews"].append_column(col)
    #sel = $glade["savedviews"].selection
    #sel.set_select_function do |selection, model, path, path_selected|
    #  model.get_iter(path)[1] == 1
    #end

    $glade["combobox1"].active=1

=begin
    fname_test = StringMetaType::PropsWidget.new("Filename", true, "DSC0002.JPG")
    fname_test.signal_connect("changed") {|wid| env binding, :wid, "wid.value"}
    $glade["vbox4"].pack_start(fname_test, false, true)
    date_test = DateMetaType::PropsWidget.new("Modified", true, Time.now)
    date_test.signal_connect("changed") {|wid| env binding, :wid, "wid.value"}
    $glade["vbox4"].pack_start(date_test, false, true)
    rank_test = RankMetaType::PropsWidget.new("Ranking", true, 3)
    rank_test.signal_connect("changed") {|wid| env binding, :wid, "wid.value"}
    $glade["vbox4"].pack_start(rank_test, false, true)
    size_test = FilesizeMetaType::PropsWidget.new("Filesize", true, 3098876)
    size_test.signal_connect("changed") {|wid| env binding, :wid, "wid.value"}
    $glade["vbox4"].pack_start(size_test, false, true)
    imsz_test = ImagesizeMetaType::PropsWidget.new("Dimensions", true, 800, 600)
    imsz_test.signal_connect("changed") {|wid| env binding, :wid, "wid.value"}
    $glade["vbox4"].pack_start(imsz_test, false, true)
    desc_test = TextMetaType::PropsWidget.new("Description", true, "fdafaf sjkdfj jksfjd jslaj jklkkjkja adkflj jkldjfkaj jskfjdl jskfldj")
    desc_test.signal_connect("changed") {|wid| env binding, :wid, "wid.value"}
    $glade["vbox4"].pack_start(desc_test, false, true)
=end
    
  end

  def init_view_icon()
    multiview = MultiView.new
    paned = $glade["vpaned1"]
    paned.remove paned.child1
    paned.pack1 multiview, true, true
  end
  
end  




TestGlade.new
Gtk.main


